<template>
  <div
    class="ui modal"
    id="new-menu-modal"
  >
    <i class="close icon"></i>
    <div class="header">
      Ajouter un nouveau menu
    </div>
    <div class="content">
      <form
        class="ui form"
        @submit.prevent="submit"
      >
        <div class="fields">
          <div class="twelve wide required field">
            <label>Plats</label>
            <input
              placeholder="Séparés par des virgules "
              type="text"
              required
              v-model="dishes"
            >
          </div>
        </div>
        <br/>

        <radio-seasons
          :season="season"
          @updateSeason="updateSeason"
        >
        </radio-seasons>
      </form>
    </div>
    <div class="actions">
      <div
        class="ui toggle checkbox"
        @click="toggleAddAnother"
      >
        <input
          name="addAnother"
          type="checkbox"
          class="hidden"
          tabindex="0"
          :checked="addAnother"
        >
        <label>Ajouter un autre ensuite</label>
      </div>

      <div
        class="ui red basic button"
        @click="cancel"
      >Anuler</div>

      <div
        class="ui primary button"
        :class="loading ? 'loading disabled' : ''"
        @click="submit"
      >OK</div>
    </div>
  </div>

</template>

<script>
import { mapActions, mapGetters } from 'vuex'

import store from '@/store/Store'
import DropdownDiet from '@/components/diets/DropdownDiet'
import RadioSeasons from './RadioSeasons'

export default {
  name: 'ModalNewMenu',
  store,
  props: {
    menuBaseId: String
  },
  data () {
    return {
      addAnother: false,
      diet: '',
      dishes: '',
      season: 'ANY'
    }
  },
  mounted () {
    // eslint-disable-next-line
    $('#new-variant-modal')
      .modal('setting', 'transition', 'scale')
  },
  methods: {
    ...mapActions({
      addMenu: 'MenusStore/addMenu'
    }),
    toggleAddAnother () {
      this.addAnother = !this.addAnother
    },
    updateDiet (id) {
      this.diet = id
    },
    updateSeason (season) {
      this.season = season
    },
    cancel () {
      // eslint-disable-next-line
      $('#new-menu-modal')
        .modal('hide')
    },
    submit () {
      var self = this

      let menu = {
        menuBase: { id_: this.menuBaseId }
      }

      if (this.diet !== '') {
        menu.diet = { _id: this.diet }
      }
      if (this.dishes !== '') {
        menu.dishes = this.dishes.split(',').map(s => s.trim())
      }

      this.addMenu(menu)
        .then((response) => {
          this.$toastr.s('Menu bien ajouté')
          if (!self.addAnother) {
            // eslint-disable-next-line
            $('#new-menu-modal')
              .modal('hide')
          }
          this.emptyModal()
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    emptyModal () {
      this.dishes = ''
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading',
      diets: 'DietsStore/diets'
    })
  },
  components: {
    DropdownDiet,
    RadioSeasons
  }
}
</script>
